package com.jkcredit.invoice.hub.config;

import com.alibaba.fastjson.JSON;
import com.jkcredit.invoice.hub.model.vo.common.AjaxResponseBody;
import com.jkcredit.invoice.hub.model.vo.common.AppResponseVo;
import com.jkcredit.invoice.hub.util.JwtTokenUtil;
import org.springframework.security.core.Authentication;
import org.springframework.security.web.authentication.AuthenticationSuccessHandler;
import org.springframework.stereotype.Component;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

@Component
public class AjaxAuthenticationSuccessHandler implements AuthenticationSuccessHandler {

    @Override
    public void onAuthenticationSuccess(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, Authentication authentication) throws IOException, ServletException {
        SelfUserDetails userDetails = (SelfUserDetails) authentication.getPrincipal();

        String jwtToken = JwtTokenUtil.generateToken(userDetails.getUsername(), 3600 * 24, "_secret");
        Map<String, String> result = new HashMap<>();
        result.put("token", jwtToken);

        httpServletResponse.setContentType("application/json;charset=UTF-8");
        httpServletResponse.setContentType("application/json");
        httpServletResponse.setStatus(HttpServletResponse.SC_OK);
        httpServletResponse.getWriter().write(JSON.toJSONString(new AppResponseVo(200, "登录成功", result)));
    }
}

